#!c:/perl/bin/perl.exe
use warnings;
use strict;
use diagnostics;

##  Simple Exact match
my $string ="aaaaaabobaaaaaa";

if ($string =~ /bob/) {
	print "I found bob!\n";
}

## Degenerate match
if ($string =~ /b.b/) {
	print "I found b[something]b!\n";
}


## Character groups
my @strings =("dog","cog","log","fog");

# Positive groups
foreach my $string (@strings) {
	if ($string =~ /[dclf]og/) {
		print "1) $string matched\n";
	}
}

# Negative groups
foreach my $string (@strings) {
	if ($string =~ /[^cl]og/) {
		print "2) $string matched\n";
	}
}


## Character group shortcuts
@strings =("dog1","dog2","dogX");

foreach my $string (@strings) {
	if ($string !~ /dog\d/) {
		print "$string had no number\n";
	}
}


## Repeated characters
$string ="aaaaXXXXaaaa";

if ($string =~ /aX{4}a/) {
	print "Matched some 'a's\n";
}

# Repeat shortcuts
my $username ="abc123";

if ($username =~ /\s+/) {
	print "You can't have spaces in a username\n";
}


## Alternatives
my $name = 'Homer';
if ($name =~ /(Bart|Lisa|Maggie)\s*Simpson/) {
	print "D'Oh!\n";
}


## Anchors
my $value = "Yah boo 123 sucks!";
if ($value =~ /\d+/) {
	print "'$value' is a number\n"; # Oh no it isn't
}

# Start / end anchors
if ($value =~/^\d+$/) {
	print "'$value' really is a number\n";
}


# Word boundary anchors
$name = "manfred";

if ($name =~/fred/) {
	print "You could be fred\n";
}

if ($name =~ /\bfred\b/) {
	print "You ARE fred\n";
}


## Case insensitive matching
if ("hELlo tHErE" =~ /hello there/i) {
	print "See, it works\n";
}





